"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeHook = exports.makeNotification = exports.ALARM_LEVEL = void 0;
const typescript_1 = require("typescript");
var ALARM_LEVEL;
(function (ALARM_LEVEL) {
    ALARM_LEVEL[ALARM_LEVEL["CRITICAL"] = 0] = "CRITICAL";
    ALARM_LEVEL[ALARM_LEVEL["FAULT"] = 1] = "FAULT";
    ALARM_LEVEL[ALARM_LEVEL["WARNING"] = 2] = "WARNING";
})(ALARM_LEVEL = exports.ALARM_LEVEL || (exports.ALARM_LEVEL = {}));
const makeNotification = (script) => {
    const jsCode = (0, typescript_1.transpile)(script, { module: typescript_1.ModuleKind.CommonJS, esModuleInterop: true, jsx: typescript_1.JsxEmit.React });
    const func = new Function("module", "exports", jsCode);
    const exports = {};
    const module = { exports };
    func(module, exports); //, microRequire(`${parent ? parent : ''}${name}`))
    return exports;
};
exports.makeNotification = makeNotification;
const makeHook = (script, pathways, raiseAlarm, sendNotification) => {
    const jsCode = (0, typescript_1.transpile)(`

    enum ALARM_LEVEL {
        CRITICAL = 'Critical',
        FAULT = 'Fault',
        WARNING = 'Warning'
    }

    enum PATHWAYS {
        ${pathways === null || pathways === void 0 ? void 0 : pathways.map((pathway) => `"${pathway.name}" = "${pathway === null || pathway === void 0 ? void 0 : pathway.name}"`).join(',\n')}
    }

        ${script}
    
    `, { module: typescript_1.ModuleKind.CommonJS, esModuleInterop: true, jsx: typescript_1.JsxEmit.React });
    const func = new Function("module", "exports", "raiseAlarm", "sendNotification", 
    // "require",
    jsCode);
    const exports = {};
    const module = { exports };
    func(module, exports, raiseAlarm, sendNotification); //, microRequire(`${parent ? parent : ''}${name}`))
    return exports;
};
exports.makeHook = makeHook;
// const a = makeHook(`
// export const handler = (tags: Tags) => {
//     console.log("a")   
//     raiseAlarm(tags.asd)
// }
// `, async (message, level, sticky) => {
//     return false;
// }, () => {
// })
// console.log(a.handler?.({}, {}));
